unity-system-compositor crashed with SIGSEGV in libinput_device_config_accel_is_available() from libinput_device_config_accel_set_speed() from mir::input::evdev::LibInputDevice::apply_settings()

Bug #1672955 reported by errors.ubuntu.com bug bridge on 2017-03-15
278
This bug affects 2 people
Affects Status Importance Assigned to Milestone
Canonical System Image
Critical
Unassigned
Mir
Critical
Andreas Pokorny
0.26
Critical
Andreas Pokorny
Unity System Compositor
Critical
Unassigned
mir (Ubuntu)
Critical
Unassigned
Xenial
Undecided
Unassigned
Yakkety
Undecided
Unassigned
Zesty
Undecided
Unassigned
unity-system-compositor (Ubuntu)
Critical
Unassigned
Xenial
Undecided
Unassigned

Bug Description

The Ubuntu Error Tracker has been receiving reports about a problem regarding unity-system-compositor. This problem was most recently seen with package version 0.9.1+17.04.20170216-0ubuntu1, the problem page at https://errors.ubuntu.com/problem/fcf5550475fb0478d6eb2a307f03705ef1ed398a contains more details, including versions of packages affected, stacktrace or traceback, and individual crash reports.
If you do not have access to the Ubuntu Error Tracker you can request it at http://forms.canonical.com/reports/.

It seems that the configuration change is requested just a moment before the device gets removed. The change actions are serialized, depending on where there memory of mir::input::DefaultDevice is allocated the segfault either occurs inside the lambda or inside underlying mir::input::LibInputDevice in the platform. The activities on input dispatch device removal and reconfiguration are serialized inside the input thread, so we just need to clean the action queue (or have multiple queues) before removing the devices.

Related branches

summary: - /usr/sbin/unity-system-
- compositor:11:libinput_device_config_accel_is_available:libinput_device_config_accel_set_speed:mir::input::evdev::LibInputDevice::apply_settings:std::function:mir::dispatch::ActionQueue::dispatch
+ unity-system-compositor crashed with SIGSEV in
+ libinput_device_config_accel_is_available() from
+ libinput_device_config_accel_set_speed() from
+ mir::input::evdev::LibInputDevice::apply_settings()
Changed in mir:
importance: Undecided → Critical
tags: added: input
Changed in mir:
milestone: none → 1.0.0
Changed in unity-system-compositor:
importance: Undecided → Critical
Changed in mir (Ubuntu):
importance: Undecided → Critical
Changed in unity-system-compositor (Ubuntu):
importance: Undecided → Critical
tags: added: unity8-desktop
Changed in canonical-devices-system-image:
importance: Undecided → Critical
milestone: none → u8c-1
description: updated
Changed in mir:
status: New → Triaged
assignee: nobody → Andreas Pokorny (andreas-pokorny)
summary: - unity-system-compositor crashed with SIGSEV in
+ unity-system-compositor crashed with SIGSEGV in
libinput_device_config_accel_is_available() from
libinput_device_config_accel_set_speed() from
mir::input::evdev::LibInputDevice::apply_settings()
Changed in mir (Ubuntu):
status: New → Triaged
Changed in unity-system-compositor:
status: New → Invalid
Changed in unity-system-compositor (Ubuntu):
status: New → Invalid
Changed in canonical-devices-system-image:
assignee: nobody → Stephen M. Webb (bregma)
status: New → Triaged
Changed in mir:
status: Triaged → In Progress
information type: Public → Public Security
kevin gunn (kgunn72) on 2017-03-20
Changed in canonical-devices-system-image:
status: Triaged → In Progress
Changed in mir (Ubuntu):
status: Triaged → In Progress
mir-ci-bot (mir-ci-bot) wrote :

Fix committed into lp:mir at revision None, scheduled for release in mir, milestone 1.0.0

Changed in mir:
status: In Progress → Fix Committed
Changed in mir (Ubuntu):
status: In Progress → Triaged
Changed in canonical-devices-system-image:
status: In Progress → Fix Committed
Stephen M. Webb (bregma) wrote :

This should not have been set to Fix Committed on system images until it's available on system images.

Changed in canonical-devices-system-image:
status: Fix Committed → In Progress
Changed in canonical-devices-system-image:
status: In Progress → Fix Committed
Changed in canonical-devices-system-image:
status: Fix Committed → Fix Released
Changed in canonical-devices-system-image:
status: Fix Released → Fix Committed
milestone: u8c-1 → u8c-z
Timo Aaltonen (tjaalton) on 2017-05-17
Changed in unity-system-compositor (Ubuntu Xenial):
status: New → Invalid

Hello errors.ubuntu.com, or anyone else affected,

Accepted mir into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/mir/0.26.3+16.04.20170510-0ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in mir (Ubuntu Xenial):
status: New → Fix Committed
tags: added: verification-needed
tags: added: verification-done
removed: verification-needed
Alan Griffiths (alan-griffiths) wrote :

Tested version 0.26.3+16.04.20170510-0ubuntu1

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package mir - 0.26.3+17.10.20170526.3-0ubuntu1

---------------
mir (0.26.3+17.10.20170526.3-0ubuntu1) artful; urgency=medium

  [ Daniel van Vugt ]
  * New upstream release 0.26.3 (https://launchpad.net/mir/+milestone/0.26.3)
    - Enhancements:
      . Make deprecations optional (and default to off for builds on 16.04 LTS)
      . Added support for building on Ubuntu 17.10 artful.
    - Bugs fixed:
      . Mir needs to be updated to 0.26 in 16.04LTS (LP: #1685186)
      . unity-system-compositor crashed with SIGSEGV in
        libinput_device_config_accel_is_available() from
        libinput_device_config_accel_set_speed() from
        mir::input::evdev::LibInputDevice::apply_settings() (LP: #1672955)
      . Please transition to Boost 1.62 (LP: #1675138)
      . Mir sending key repeat events continually to nested shell after VT
        switch (causes Unity8 lockup for a while) (LP: #1675357)
      . mir_demo_standalone_render_overlays fails to link (LP: #1677239)

 -- Alan Griffiths <email address hidden> Fri, 26 May 2017 16:57:20 +0000

Changed in mir (Ubuntu):
status: Triaged → Fix Released
Chris Halse Rogers (raof) wrote :

Hello errors.ubuntu.com, or anyone else affected,

Accepted mir into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/mir/0.26.3+16.04.20170605-0ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: removed: verification-done
tags: added: verification-needed
Changed in mir (Ubuntu Yakkety):
status: New → Fix Committed
Chris Halse Rogers (raof) wrote :

Hello errors.ubuntu.com, or anyone else affected,

Accepted mir into yakkety-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/mir/0.26.3+16.10.20170605-0ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Chris Halse Rogers (raof) wrote :

Hello errors.ubuntu.com, or anyone else affected,

Accepted mir into zesty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/mir/0.26.3+17.04.20170605-0ubuntu1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in mir (Ubuntu Zesty):
status: New → Fix Committed
Michał Sawicz (saviq) wrote :

Tested:
xenial: 0.26.3+16.04.20170605-0ubuntu1
yakkety: 0.26.3+16.10.20170605-0ubuntu1
zesty: 0.26.3+17.04.20170605-0ubuntu1

Changed in mir:
status: Fix Committed → Fix Released
tags: added: verification-done
removed: verification-needed
tags: added: verification-done-xenial verification-done-yakkety verification-done-zesty
removed: verification-done

The verification of the Stable Release Update for mir has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package mir - 0.26.3+16.10.20170605-0ubuntu1

---------------
mir (0.26.3+16.10.20170605-0ubuntu1) yakkety; urgency=medium

  [ Daniel van Vugt ]
  * New upstream release 0.26.3 (https://launchpad.net/mir/+milestone/0.26.3)
    - Enhancements:
      . Make deprecations optional (and default to off for builds on 16.04 LTS)
      . Added support for building on Ubuntu 17.10 artful.
    - Bugs fixed:
      . Mir needs to be updated to 0.26 in 16.04LTS (LP: #1685186)
      . unity-system-compositor crashed with SIGSEGV in
        libinput_device_config_accel_is_available() from
        libinput_device_config_accel_set_speed() from
        mir::input::evdev::LibInputDevice::apply_settings() (LP: #1672955)
      . Please transition to Boost 1.62 (LP: #1675138)
      . Mir sending key repeat events continually to nested shell after VT
        switch (causes Unity8 lockup for a while) (LP: #1675357)
      . mir_demo_standalone_render_overlays fails to link (LP: #1677239)

 -- Michał Sawicz <email address hidden> Mon, 05 Jun 2017 13:46:05 +0000

Changed in mir (Ubuntu Yakkety):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package mir - 0.26.3+16.04.20170605-0ubuntu1

---------------
mir (0.26.3+16.04.20170605-0ubuntu1) xenial; urgency=medium

  [ Daniel van Vugt ]
  * New upstream release 0.26.3 (https://launchpad.net/mir/+milestone/0.26.3)
    - Enhancements:
      . Make deprecations optional (and default to off for builds on 16.04 LTS)
      . Added support for building on Ubuntu 17.10 artful.
    - Bugs fixed:
      . Mir needs to be updated to 0.26 in 16.04LTS (LP: #1685186)
      . unity-system-compositor crashed with SIGSEGV in
        libinput_device_config_accel_is_available() from
        libinput_device_config_accel_set_speed() from
        mir::input::evdev::LibInputDevice::apply_settings() (LP: #1672955)
      . Please transition to Boost 1.62 (LP: #1675138)
      . Mir sending key repeat events continually to nested shell after VT
        switch (causes Unity8 lockup for a while) (LP: #1675357)
      . mir_demo_standalone_render_overlays fails to link (LP: #1677239)

 -- Michał Sawicz <email address hidden> Mon, 05 Jun 2017 11:01:05 +0000

Changed in mir (Ubuntu Xenial):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package mir - 0.26.3+17.04.20170605-0ubuntu1

---------------
mir (0.26.3+17.04.20170605-0ubuntu1) zesty; urgency=medium

  [ Daniel van Vugt ]
  * New upstream release 0.26.3 (https://launchpad.net/mir/+milestone/0.26.3)
    - Enhancements:
      . Make deprecations optional (and default to off for builds on 16.04 LTS)
      . Added support for building on Ubuntu 17.10 artful.
    - Bugs fixed:
      . Mir needs to be updated to 0.26 in 16.04LTS (LP: #1685186)
      . unity-system-compositor crashed with SIGSEGV in
        libinput_device_config_accel_is_available() from
        libinput_device_config_accel_set_speed() from
        mir::input::evdev::LibInputDevice::apply_settings() (LP: #1672955)
      . Please transition to Boost 1.62 (LP: #1675138)
      . Mir sending key repeat events continually to nested shell after VT
        switch (causes Unity8 lockup for a while) (LP: #1675357)
      . mir_demo_standalone_render_overlays fails to link (LP: #1677239)

 -- Michał Sawicz <email address hidden> Mon, 05 Jun 2017 11:04:47 +0000

Changed in mir (Ubuntu Zesty):
status: Fix Committed → Fix Released
Daniel van Vugt (vanvugt) wrote :

Minor correction - Mir 0.27.0 is not released yet :)

Changed in mir:
status: Fix Released → Fix Committed
Changed in canonical-devices-system-image:
assignee: Stephen M. Webb (bregma) → nobody
status: Fix Committed → Fix Released
Changed in mir:
milestone: 0.27.0 → none
status: Fix Committed → Fix Released
milestone: none → 0.27.0
To post a comment you must log in.
This report contains Public Security information  Edit
Everyone can see this security related information.

Duplicates of this bug

Other bug subscribers